
% ========================================================================
% 
%   MatLab or Octave program to read and manipulate the data used in
%   the Sinaia 07 exercises.
%
%   SEH, GP, 31 May 2007
%
% ========================================================================



%%  -- first we load the 17x3 data matrix 

D = load("B_field_SC2.txt")
N = 17;



%% -- plot the data 

subplot(3,1,1);  plot( D(:,1),'L' );
subplot(3,1,2);  plot( D(:,2),'L' );
subplot(3,1,3);  plot( D(:,3),'L' );



%%  -- the observation mean (sample mean)

AveB = mean(D)



%% -- calculate the mean corrected matrix B 
  
for i=1:N,
  B(i,:) = D(i,:) - AveB;
end
B



%%  -- calculate the covariance matrix of X according to Eq. 3.14

Q = B' * B / N



%%   --calculate eigenvalues and eigenvectors. 
%%  Note that MatLab and Octave sorts the eigenvectors and eigenvalues
%%  in ascencing order - other packages does the opposite, or does
%%  not sort at all.

[A,lambda] = eig(Q)



%%  --calculate the Y matrix (principal components) 
%%  Column 1 in Y is here the component with MINIMUM variance, 
%%  corresponding to the SMALLEST eigenvalue

Y = B * A


%%  -- singular value decomposition of B.
%%  Note that sense of the V matrix, and hence U matrix 
%%  are flipped compared to those in the book. 

[U,W,V] = svd(B, 0)





%% -- end of program

